currowcol1	equ	saferam
currowcol2	equ	saferam+2
currentstr	equ	saferam+3 ;2bytes
lengthofstr	equ	saferam+5 ;1bytes
columns		equ	saferam+6 ;1byte
rows			equ	saferam+7 ;1byte
cursorlocation equ saferam+8 ;1byte
tablestr		equ	saferam+9 ;2bytes
strsafe		equ	saferam+11

railfence1:
	call VPutSscreen
 db "Rail Fence - Intro",0
 db "The  Rail Fence cipher",0
 db "uses a table to encrypt.",0
 db "You write your message",0
 db "horizontally in a table of X",0
 db "columns, then read them",0
 db "vertically and write them",0
 db "down.",0
 db 0FFh
	ret

 ifdef unused
railfence2:
	call VPutSscreen
 db "Rail Fence - Encrypt",0
 db "For more security, you",0
 db "write them down in a",0
 db "different order. That",0
 db "order with X is the key",0
 db "for this cipher",0
 db 0FFh
	ret
 endif

railfence2:
	call VPutSscreen
 db "Rail Fence - Example",0
 db "This is what happens when",0
 db "you encrypt with X=6",0
 db 0FFh
	PutS 1,3,"THISIS"
	PutS 1,4,"ATESTM"
	PutS 1,5,"ESSAGE"
	ret
railfence2_ani:
	call railfence2
	set fastforwardicon,(IY+asm_Flag2)
	res fastforward,(IY+asm_Flag1)
	ld hl,1*256+2
	ld (currowcol1),hl
	ld hl,8*256+3
	ld (currowcol2),hl
	ld hl,railfence2_str
	ld b,6
railfence2_bigloop:
	push bc
	ld b,3
railfence2_smallloop:
	push bc
	call Delay100
	pop bc
	ex de,hl
	ld hl,(currowcol1)
	inc l
	ld (currow),hl
	ld (currowcol1),hl
	ex de,hl
	ld a,(hl)
	inc hl
	set textInverse, (IY + textFlags)
	B_CALL PutMap
	res textInverse, (IY + textFlags)
	ex de,hl
	ld hl,(currowcol2)
	inc h
	ld (currow),hl
	ld (currowcol2),hl
	ex de,hl
	B_CALL PutMap
	djnz railfence2_smallloop
	pop bc
	push hl
	ld hl,(currowcol1)
	inc h
	ld l,2
	ld (currowcol1),hl
	ld hl,(currowcol2)
	ld a,11
	cp h
	jr z,railfence2_bigloop_skip
	inc l
	ld h,8
	ld (currowcol2),hl
railfence2_bigloop_skip:
	pop hl
	djnz railfence2_bigloop
	res fastforwardicon,(IY+asm_Flag2)
	ret
railfence2_str:
	db "TAEHTSIESSSAITGSME",0

railfence3:
	call VPutSscreen
 db "Rail Fence - Crack",0
 db "This cipher can be cracked",0
 db "easily if you know one word",0
 db "that's in the message. You",0
 db "look for the first character",0
 db "and then read the message",0
 db "cyclic untill you see the",0
 db "next character.",0
 db 0FFh
	ret

railfence4:
	call VPutSscreen
 db "Rail Fence - Crack2",0
 db "The number of characters",0
 db "between the 2 characters",0
 db "(+1) is a possible number",0
 db "of rows in the table. If the",0
 db "table doesn't make sense,",0
 db "you continue looking for",0
 db "the character.",0
 db 0FFh
	ret

railfence5:
	call VPutSscreen
 db "Rail Fence - Crackexample",0
 db "Let's crack a message with",0
 db "the word \"me\" in it.",0
 db 0FFh
	ld b,3
	ld hl,railfence5_encodedstr
	call MultiPutS
	ret
railfence5_ani:
	set fastforwardicon,(IY+asm_Flag2)
	call railfence5
 	call railfence5_searching
	VPutSScreen 55,30,"M..."
 	res fastforward,(IY+asm_Flag1)
	ld bc,0*256+4
	ld (curRow),bc 
	ld b,2 ;c not 0
	call railfence5_selectarrow
	ld a,LsqUp
	B_CALL PutC
	VPutSScreen 55,37,"E..."
	call Delay100_double
	ld bc,3*256
	call railfence5_selectarrow
	VPutSScreen 55,44,"Found"
	set continueicon,(IY+asm_Flag2)
	res fastforwardicon,(IY+asm_Flag2)
	B_CALL GetKey ;cont
	call smallreadkeys
	B_CALL GrBufCpy
	call railfence5_tryingtable
	ld b,3
	ld hl,railfence5_table3x4
	call MultiPutS
	VPutSScreen 55,37,"Nonsense..."
	B_CALL GetKey ;cont
	call smallreadkeys
	set fastforwardicon,(IY+asm_Flag2)
	res continueicon,(IY+asm_Flag2)
	B_CALL GrBufCpy
	res fastforward,(IY+asm_Flag1)
	ld b,3
	ld hl,railfence5_encodedstr
	call MultiPutS
	call PutSMacro
	db 2,4
	db LsqUp,0
	call railfence5_searching
	VPutSScreen 55,30,"E again..."
	ld bc,5*256+4
	ld (curRow),bc 
	ld bc,2*256
	call railfence5_selectarrow
	VPutSScreen 55,37,"Found"
	set continueicon,(IY+asm_Flag2)
	res fastforwardicon,(IY+asm_Flag2)
	B_CALL GetKey ;cont
	call smallreadkeys
	set fastforwardicon,(IY+asm_Flag2)
	res continueicon,(IY+asm_Flag2)
	B_CALL GrBufCpy
	call railfence5_tryingtable
	ld b,4
	ld hl,railfence5_table4x3
	call MultiPutS
	VPutSScreen 55,37,"Cracked"
	res fastforwardicon,(IY+asm_Flag2)
	ret

railfence5_searching:
	VPutSScreen	55,23,"Searching:" 
	ret

railfence5_tryingtable:
	VPutSScreen 55,23,"Trying"
	VPutSScreen 55,30,"table..."
	ret

railfence5_selectarrow:
	ld a,c
	or a
	jr z,railfence5_selectarrow_skip
	push bc
	call Delay100_double
	pop bc
	ld a,Lspace
	B_CALL PutC
railfence5_selectarrow_skip:
	ld c,1
	ld a,LsqUp
	B_CALL PutMap
	djnz railfence5_selectarrow
	ret
	
railfence5_encodedstr:
 db "SMVLEEEL",0,0
 db "NFDADIOR",0

railfence5_table3x4:
 db "SLEF",0
 db "MELD",0
 db "VENA",0

railfence5_table4x3:
 db "SEND",0
 db "MEFI",0
 db "VEDO",0
 db "LLAR",0

railfence6:
	pop hl ;delete ret
railfence6_nopop:
	res noicon,(IY+asm_Flag2)
	ld a,1
railfence6_redraw:
	ld (currentselected),a
	B_CALL GrBufClr
	ld b,2
	push bc
	call vakjes
	pop bc
	call vakjecijfers
	ld a,(currentselected)
	push af
	call vakjeinvert
	pop af
	dec a
	jr nz,railfence6_display2
	VPutSI 16,12,"Crack with help"
	VPutS 18,20,"Crack a code using"
	VPutS 18,27,"a decrypt program"
	ld hl,12*256+11
	ld de,19*256+15
	call fillrect
	ld hl,18*256+15
	ld bc,35*256+82
	call Drawrect
	jr railfence6_display1
railfence6_display2:
	VPutSI 16,22,"Crack manually"
	VPutS 18,30,"Crack a code"
	VPutS 18,37,"manually"
	ld hl,22*256+11
	ld de,29*256+15
	call fillrect
	ld hl,28*256+15
	ld bc,45*256+82
	call Drawrect
railfence6_display1:
	call VPutSscreen
 db "Rail Fence - Exercises",0
 db 0
 db 0FFh
railfence6_keyloop:
	B_CALL GetKey ;temporarily to allow screenshots
	cp kUp
	jr z,railfence6_up
	cp kDown
	jr z,railfence6_down
	cp kEnter
	jr z,railfence6_enter
	cp k1
	jr z,railfence6_decryptprog
	cp k2
	jr z,railfence6_decryptman
	call readkeys
	jr railfence6_keyloop

railfence6_up:
	ld a,1
	jr railfence6_redraw
railfence6_down:
	ld a,2
	jr railfence6_redraw

railfence6_enter:
	ld a,(currentselected)
	dec a
	jr z,railfence6_decryptprog
	jr railfence6_decryptman


selectstr:
 db "       SELECT",0

tryagainstr:
 db "  TRY AGAIN",0

newstr:
 db "  NEW",0

railfence6_decryptprog:
	set noicon,(IY+asm_Flag2)
	call railfence6_randstr
railfence6_decryptprog_norandstr:
	B_CALL GrBufClr
	ld hl,quitstr
	ld a,0
	call Displaykey15
	ld hl,selectstr
	ld a,18
	ld c,36
	call Displaykey
	ld hl,newstr
	ld a,57
	call Displaykey15
	call VPutSscreen
 db "Rail Fence - Exercises",0
 db "Select the characters",0
 db "using the arrowkeys. The",0
 db "known word is ",0
 db 0FFh
	ld hl,(currentstr)
	xor a
	ld c,0FFh
	cpir
	res textWrite, (IY + sGrFlags)
	call VPutS
	set textWrite, (IY + sGrFlags)
	ld hl,1*256+5
	push hl
	ld (currow),hl
	set appTextSave, (IY + appFlags)
	ld hl,strsafe+1
	call railfence6_decryptman_displaystr14
	pop hl
	ld (currow),hl
	xor a
	ld (cursorlocation),a
	call railfence6_decryptprog_putcursorat
	set curAble,(IY+curFlags)
	ld a,0FFh
	ld (currentselected),a
railfence6_decryptprog_keyloop:
	B_CALL GetKey
	ld hl,cursorlocation
	ld b,(hl)
	cp kUp
	jr z,railfence6_decryptprog_up
	cp kDown
	jr z,railfence6_decryptprog_down
	cp kLeft
	jr z,railfence6_decryptprog_left
	cp kRight
	jr z,railfence6_decryptprog_right
	cp kBOL
	jr z,railfence6_decryptprog_BOL
	cp kEOL
	jr z,railfence6_decryptprog_EOL
	cp kEnter
	jr z,railfence6_decryptprog_enter
	cp kWindow
	jr z,railfence6_decryptprog_enter
	cp kZoom
	jr z,railfence6_decryptprog_enter
	cp kTrace
	jr z,railfence6_decryptprog
	cp kYequ
	jr z,railfence6_decryptprog_exit
	call readkeys
	jr railfence6_decryptprog_keyloop

railfence6_decryptprog_enter:
	ld hl,currentselected
	ld a,(hl)
	inc a
	jr nz,railfence6_decryptprog_enter_showtable
	ld a,(cursorlocation)
	ld (hl),a
	VPutSScreen 4,30,"First char is "
	call railfence6_decryptprog_getcurchar
	res textWrite, (IY + sGrFlags)
	B_CALL VPutMap
	set textWrite, (IY + sGrFlags)
	jr railfence6_decryptprog_keyloop

railfence6_decryptprog_enter_showtable:
	dec a ;selected1
	ld b,a
	ld a,(cursorlocation)
	sub b
	jr z,railfence6_decryptprog_keyloop
	jp ns,railfence6_decryptprog_enter_showtable_nocpl
	ld a,(cursorlocation)
	ld c,a
	ld a,(strsafe)
	dec a
	sub b
	add c
railfence6_decryptprog_enter_showtable_nocpl:
	push af
	res curAble,(IY+curFlags)
	B_CALL GrBufClr
	ld hl,quitstr
	ld a,0
	call Displaykey15
	ld hl,tryagainstr
	ld a,18
	ld c,36
	call Displaykey
	ld hl,newstr
	ld a,57
	call Displaykey15
	pop af
	ld c,a
	ld hl,1*256+2
	ld (currow),hl
	ld hl,strsafe
	push hl
	ld e,(hl)
	ld d,0
	push de
	ex de,hl
	B_CALL DivHLByA
	or a
	jr nz,railfence6_decryptprog_enter_showtable_nocompletetable
	ld b,l
	push bc
	push af
	call VPutSscreen
 db "Rail Fence - Exercises",0
 db "Table you suggested:",0
 db 0FFh
	pop af
	pop bc
	pop de
	pop hl
	inc e
	inc e
	add hl,de
	ex de,hl
	ld hl,strsafe+1
	push bc
	call railfence6_transpose
	pop bc
	xor a
	ld (cursorlocation),a
	ld a,c
	ld (columns),a
	ld b,c
	inc b
	ld c,6
	ld (tablestr),hl
	call railfence6_decryptman_displaystr
railfence6_decryptprog_enter_showtable_keyloop:
	B_CALL GetKey
	cp kUp
	jr z,railfence6_decryptprog_enter_showtable_up
	cp kDown
	jr z,railfence6_decryptprog_enter_showtable_down
	call railfence6_decryptprog_readkeys
	jr railfence6_decryptprog_enter_showtable_keyloop

railfence6_decryptprog_enter_showtable_up:
	ld hl,cursorlocation
	ld a,(hl)
	or a
	jr z,railfence6_decryptprog_enter_showtable_keyloop
	dec a
	ld (hl),a
railfence6_decryptprog_enter_showtable_move:
	push af
	B_CALL GrBufCpy
	pop af
	ld b,a
	ld hl,0*256+2
	ld (currow),hl
	or a
	ld a,Lspace
	jr z,railfence6_decryptprog_enter_showtable_move_noarrow
	ld a,LupArrow
railfence6_decryptprog_enter_showtable_move_noarrow:
	B_CALL PutC
	ld a,(columns)
	or a
	jr z,railfence6_decryptprog_enter_showtable_skipmult
	ld c,a
	xor a
railfence6_decryptprog_enter_showtable_multloop:
	add c
	djnz railfence6_decryptprog_enter_showtable_multloop
railfence6_decryptprog_enter_showtable_skipmult
	ld e,a
	ld d,0
	ld hl,(tablestr)
	add hl,de
	ld a,(columns)
	ld b,a
	inc b
	ld c,6
	call railfence6_decryptman_displaystr
	jr railfence6_decryptprog_enter_showtable_keyloop

railfence6_decryptprog_enter_showtable_down:
	ld hl,cursorlocation
	ld a,(rows)
	sub 4
	jr c,railfence6_decryptprog_enter_showtable_keyloop
	jr z,railfence6_decryptprog_enter_showtable_keyloop
	cp (hl)
	jr z,railfence6_decryptprog_enter_showtable_keyloop
	inc (hl)
	ld a,(hl)
	jr railfence6_decryptprog_enter_showtable_move


railfence6_decryptprog_enter_showtable_nocompletetable:
	call VPutSscreen
 db "Rail Fence - Exercises",0
 db "Table you suggested can't",0
 db "be filled completely. You",0
 db "Should try another one.",0
 db 0FFh
railfence6_decryptprog_enter_showtable_notcomplete_keyloop:
	B_CALL GetKey
	call railfence6_decryptprog_readkeys
	jr railfence6_decryptprog_enter_showtable_notcomplete_keyloop

railfence6_decryptprog_readkeys:
	pop hl
	cp kWindow
	jr z,railfence6_decryptprog_norandstr
	cp kZoom
	jr z,railfence6_decryptprog_norandstr
	cp kTrace
	jr z,railfence6_decryptprog
	push hl
	jr railfence6_readkeys


railfence6_decryptprog_exit:
	res curAble,(IY+curFlags)
	jr railfence6_nopop

	
railfence6_decryptprog_BOL:
	ld a,b
	cp 13
	ld a,13
	jr nc,railfence6_decryptprog_move_key
	xor a
	jr railfence6_decryptprog_move_key
railfence6_decryptprog_EOL:
	ld a,b
	cp 13
	ld a,12
	jr c,railfence6_decryptprog_move_key
	ld a,(strsafe)
	dec a
	jr railfence6_decryptprog_move_key
railfence6_decryptprog_up:
	ld a,b
	cp 13
	jr c,railfence6_decryptprog_keyloop
	sub 13
	jr railfence6_decryptprog_move_key
railfence6_decryptprog_down:
	ld a,b
	cp 13
	jr nc,railfence6_decryptprog_keyloop
	add 13
	jr railfence6_decryptprog_putcursoratifvalid
railfence6_decryptprog_left:
	ld a,b
	or a
	jr z,railfence6_decryptprog_left_wrap
	dec a
	jr railfence6_decryptprog_move_key
railfence6_decryptprog_left_wrap:
	ld a,(strsafe)
	dec a
	jr railfence6_decryptprog_move_key
railfence6_decryptprog_right:
	ld a,b
	inc a
railfence6_decryptprog_putcursoratifvalid:
	push af
	ld a,(strsafe)
	ld b,a
	pop af
	cp b
	jr c,railfence6_decryptprog_move_key
	xor a
railfence6_decryptprog_move_key:
	call railfence6_decryptprog_putcursorat
	jr railfence6_decryptprog_keyloop

railfence6_decryptprog_putcursorat:
	push af
	call railfence6_decryptprog_getcurchar
	B_CALL PutMap
	pop af
	ld (cursorlocation),a
	ld l,5
	cp 13
	jr c,railfence6_decryptprog_putcursorat_skipinc
	sub 13
	inc l
railfence6_decryptprog_putcursorat_skipinc:
	inc a
	ld h,a
	ld (currow),hl
	call railfence6_decryptprog_getcurchar
	ld (curunder),a
	ret

railfence6_decryptprog_getcurchar:
	ld a,(cursorlocation)
	ld e,a
	ld d,0
	ld hl,strsafe+1
	add hl,de
	ld a,(hl)
	ret

railfence6_decryptman:
	set noicon,(IY+asm_Flag2)
	B_CALL GrBufClr
	ld hl,quitstr
	ld a,0
	call Displaykey15
	ld hl,ansstr
	ld a,18
	call Displaykey15
	call VPutSscreen
 db "Rail Fence - Exercises",0
 db "Try to decrypt manually.",0
 db "The known word is ",0
 db 0FFh
	call railfence6_randstr
	ld hl,(currentstr)
	xor a
	ld c,0FFh
	cpir
	res textWrite, (IY + sGrFlags)
	call VPutS
	set textWrite, (IY + sGrFlags)
	ld hl,1*256+3
	ld (currow),hl
	ld hl,strsafe+1
	call railfence6_decryptman_displaystr14
railfence6_decryptman_keyloop:
	B_CALL GetKey
	cp kWindow
	jr z,railfence6_decryptman_ans
	call railfence6_readkeys
	jr railfence6_decryptman_keyloop

railfence6_decryptman_ans:
	ld hl,1*256+5
	ld (currow),hl
	ld hl,(currentstr)
	call railfence6_decryptman_displaystr14
	VPutSScreen 20,57,"CONT"
	ld bc,35*256+6
	B_CALL PointOn
railfence6_decryptman_ans_keyloop:
	B_CALL GetKey
	cp kWindow
	jr z,railfence6_decryptman
	call railfence6_readkeys
	jr railfence6_decryptman_ans_keyloop

railfence6_readkeys:
	pop hl
	cp kLeft
	jr z,railfence6_nopop
	cp kRight
 	jr z,railfence6_nopop
	cp kYequ
	jr z,railfence6_nopop
	push hl
	jr readkeys

railfence6_randstr:
	B_CALL Random
	ld hl,railfence6_messages
	ld de,(OP1+2)
	ld a,d
	and 0Fh
	add a
	ld d,a
	add a
	add a
	add d ;a*10
	ld d,a
	ld a,e
	and 0Fh
	add d 
	srl a
	srl a ;random nr van 0 tot 24
	add a ;vanwege hints
	jr z,railfence6_randstr_skipstrloop
	ld b,a
	jr z,railfence6_randstr_skipstrloop
	xor a
railfence6_randstr_findstrloop:
	ld c,0FFh
	cpir
	djnz railfence6_randstr_findstrloop
railfence6_randstr_skipstrloop:
	ld a,(OP1+4)
	cp 70h
	jr c,railfence6_randstr_option1
	ld c,(hl)
	inc hl
	ld b,(hl)
	jr railfence6_randstr_option2
railfence6_randstr_option1:
	ld b,(hl)
	inc hl
	ld c,(hl)
railfence6_randstr_option2:
	inc hl
	ld (currentstr),hl
	ld de,strsafe+1
	call railfence6_transpose
	B_CALL StrLength
	dec hl
	ld (hl),c
	ret

railfence6_transpose:
	ld a,b
	dec a
	ld (rows),a
	push bc
	xor a
railfence6_transpose_multloop:
	add c
	djnz railfence6_transpose_multloop
	ld (lengthofstr),a
	pop bc
	push de
railfence6_transpose_bigloop:
	push bc
	push de
	ld b,c
railfence6_transpose_smalloop:
	ldi
	push hl
	ld a,(rows)
	ld h,0
	ld l,a
	add hl,de
	ex de,hl
	pop hl
	djnz railfence6_transpose_smalloop
	pop de
	pop bc
	inc de
	djnz railfence6_transpose_bigloop
	ld a,(lengthofstr)
	ld d,0
	ld e,a
	pop hl
	push hl
	add hl,de
	xor a
	ld (hl),a
	pop hl
	ret

railfence6_decryptman_displaystr14:
	ld bc,14*256+6
railfence6_decryptman_displaystr:
	ld a,(hl)
	inc hl
	or a
	ret z
	B_CALL PutC
	ld de,(currow)
	ld a,d
	cp b
	jr nz,railfence6_decryptman_displaystr
	ld d,1
	ld a,e
	cp c
	jr z,railfence6_decryptman_displaydownarrow
	inc e
	ld (currow),de
	jr railfence6_decryptman_displaystr
railfence6_decryptman_displaydownarrow:
	ld a,(hl)
	or a
	ret z
	ld d,0
	ld (currow),de
	ld a,LdownArrow
	B_CALL PutMap
	ret

railfence6_messages:
 db 3,4,"THISISSECRET",0,"IS",0
 db 3,5,"CEASARANDBRUTUS",0,"AND",0
 db 3,6,"AVERYSECRETMESSAGE",0,"SECRET",0
 db 3,6,"THISISNOTIMPORTANT",0,"NOT",0
 db 3,6,"THEUNIVERSEISLARGE",0,"LARGE",0
 db 3,6,"TWOTOTHEPOWERTHREE",0,"POWER",0
 db 3,7,"THEBLACKCATISDRINKING",0,"CAT",0
 db 3,7,"FORTYTWOISTHEQUESTION",0,"THE",0

 db 4,5,"TRAINSSTOPATSTATIONS",0,"STOP",0
 db 4,5,"PLEASEDONOTCRACKTHIS",0,"NOT",0
 db 4,5,"DONTPANICSAYSTHEBOOK",0,"SAYS",0
 db 4,5,"COMPUTERSARENOTSMART",0,"ARE",0
 db 4,6,"SPRINGSUMMERAUTUMNWINTER",0,"SUMMER",0
 db 4,6,"YOUCRACKEDMESOICANBEREAD",0,"ME",0
 db 4,6,"THESHIPTHATCANNOTGOWRONG",0,"SHIP",0
 db 3,4,"BIRDSFLYHIGH",0,"FLY",0
 db 3,5,"THEOCEANSAREBIG",0,"ARE",0
 db 3,5,"THANKSFORTHESUN",0,"SUN",0
 db 3,5,"THEMATRIXHASYOU",0,"YOU",0
 db 3,7,"THEARMYUSESENCRYPTION",0,"USES",0

 db 3,4,"JUSTSOMETEXT",0,"TEXT",0
 db 2,7,"SCHOOLSHOULDBENICE",0,"NICE",0
 db 2,9,"THEREALLYBIGBUTTON",0,"BIG",0
 db 4,4,"LISTENTOTHEMUSIC",0,"MUSIC",0
 db 3,5,"ATIGERISRUNNING",0,"RUNNING",0
