jefferson1:
	call VPutSscreen
 db "Jefferson - Intro",0
 db "This cipher uses X wheels",0
 db "with a different scrambled",0
 db "alphabet on each of them.",0
 db "The wheels are next to",0
 db "each other and have even",0
 db "spacing between the",0
 db "characters.",0
 db 0FFh
 	ret


jefferson2:
	call VPutSscreen
 db "Jefferson - Encoding",0
 db "You rotate the wheels so",0
 db "that your message is on one",0
 db "row, then you write down",0
 db "a random row. To decode",0
 db "you make the random row",0
 db "again and look for a row",0
 db "that's in English.",0
 db 0FFh
 	ret

jefferson3:
	call VPutSscreen
 db "Jefferson - Example",0
 db "An example with 5 wheels",0
 db "of only 4 characters.",0
 db 0FFh
	call jefferson3_wheels_displaynewwheels
	ret
jefferson3_ani:
	set fastforwardicon,(IY+asm_Flag2)
	VPutS	38,23,"Rotating..."
	call jefferson3
 	res fastforward,(IY+asm_Flag1)
	ld hl,tempSwapArea
	ld d,0
	call jefferson3_putarrow
	ld a,"W"
	call jefferson3_wheels_rotatetill
	ld d,1
	call jefferson3_putarrow
	ld a,"H"
	call jefferson3_wheels_rotatetill
	ld d,2
	call jefferson3_putarrow
	ld a,"E"
	call jefferson3_wheels_rotatetill
	ld d,3
	call jefferson3_putarrow
	ld a,"E"
	call jefferson3_wheels_rotatetill
	ld d,4
	call jefferson3_putarrow
	ld a,"L"
	call jefferson3_wheels_rotatetill
	PutS 5,7," "
	res fastforward,(IY+asm_Flag1)
jefferson3_pickarow:
	VPutSScreen	38,30,"Picking a row..."
	ld hl,jefferson3_pickarow+3
	call VPutSMacros
	call jefferson3_wheels_selectrow
	set continueicon,(IY+asm_Flag2)
	res fastforwardicon,(IY+asm_Flag2)
	B_CALL GetKey ;display cont
	call smallreadkeys
	set fastforwardicon,(IY+asm_Flag2)
	res continueicon,(IY+asm_Flag2)
	VPutS 38,37,"Rotating to row..."
	B_CALL GrBufCpy
	call jefferson3_wheels_displaynewwheels
	ld hl,tempSwapArea
;	ld a,"H"
;	call jefferson3_wheels_rotatetill
	ld d,0
	call jefferson3_putarrow
	inc hl
	ld d,1
	call jefferson3_putarrow
	ld a,"L"
	call jefferson3_wheels_rotatetill
	ld d,2
	call jefferson3_putarrow
;	call jefferson3_wheels_rotatetill
	ld d,3
	call jefferson3_putarrow
	inc hl
	ld a,"H"
	call jefferson3_wheels_rotatetill
	ld d,4
	call jefferson3_putarrow
	ld a,"E"
	call jefferson3_wheels_rotatetill
	PutS 5,7," "
	VPutSScreen 38,44,"Pick English row"
	res fastforward,(IY+asm_Flag1)
	call Delay100_double
	call jefferson3_wheels_selectrow
	res fastforwardicon,(IY+asm_Flag2)
 	ret

jefferson3_putarrow:
	ld e,7
	ld (currow),de
	ld a," "
	B_CALL PutC
	ld a,LUpBlk
	B_CALL PutC
	ret

jefferson3_wheels_selectrow:
	ld hl,1*256+5
	ld (curRow),hl
	ld hl,tempSwapArea+2*6
	set textInverse, (IY + textFlags)
	B_CALL PutS
	res textInverse, (IY + textFlags)
	ret

jefferson3_wheels_displaynewwheels:
	ld hl,jefferson3_wheels	
	ld de,tempSwapArea
	ld bc,jefferson3_wheels_end-jefferson3_wheels
	ldir
jefferson3_wheels_displaywheels:
	ld b,4
	ld hl,tempSwapArea
	jr MultiPutS

jefferson3_wheels_rotatetill:
	push af
	call Delay100_double
	call jefferson3_wheels_rotate
	pop af
	cp (hl)
	jr nz,jefferson3_wheels_rotatetill
	inc hl
	ret

jefferson3_wheels_rotate:
	ld a,(hl)
	ld de,6
	ld b,3
	push hl
jefferson3_wheels_rotate_loop:
	add hl,de
	ld c,(hl)
	ld (hl),a
	ld a,c
	djnz jefferson3_wheels_rotate_loop
	pop hl
	ld (hl),a
	push hl
	call jefferson3_wheels_displaywheels
	pop hl
	ret

jefferson3_wheels:
 db "HWHLW",0
 db "ELWEL",0
 db "WEEWH",0
 db "LHLHE",0
jefferson3_wheels_end:


jefferson4:
	call VPutSscreen
 db "Jefferson - Crack",0
 db "This cipher is hard to crack",0
 db "because the key has X*26!",0
 db "possibilities. The random",0
 db "row makes cracking",0
 db "harder because the same",0
 db "text has more than one",0
 db "code.",0
 db 0FFh
 	ret

jefferson5:
	call VPutSscreen
 db "Jefferson - Exercise",0
 db "Because this cipher is hard",0
 db "to crack there are no",0
 db "exercises.",0
 db 0FFh
 	ret